--[[
	Project: SoulEnergyTracker
	Friendly Name: Soul Energy Tracker
	Author:

	File: init.lua
	Purpose: Initialization, Engine Setup

	Version: 2

	ALL RIGHTS RESERVED.
	COPYRIGHT (c)2015 VANDESDELCA32
]]

-- GLOBALS: SLASH_SOULENERGY2, SLASH_SOULENERGY1, SlashCmdList
local tconcat, tostringall = table.concat, tostringall

local AddonName, Engine = ...

local MyAddon = LibStub("AceAddon-3.0"):NewAddon(AddonName, "AceEvent-3.0", "AceTimer-3.0", "AceComm-3.0", "AceSerializer-3.0")
LibStub("LibVan32-1.0"):Embed(MyAddon, AddonName)

--[===[@debug@
MyAddon._DebugMode = true
--@end-debug@]===]

------------------
-- Debug Functions
------------------
function MyAddon.printFuncName(func, ...)
  local argList = tconcat({tostringall(...)}, "§r,§6 ")
  return MyAddon:PrintDebug("§a" .. func .. "§f(§6" .. (argList or "") .. "§f)")
end

MyAddon._Major = "r3" or ""
MyAddon._Minor = tonumber("3") or "DEV_BUILD"

local Defaults = { -- Settings
  _Version = 1,
  Maximum = 250,
  Last_Value = 0,
  Update_Interval = 10,
  Decline = {
    Interval = 120,
    Amount = 1,
    Auto_Rate = 0.01,
  },
  _LastChange = -1,
}

Engine[1] = MyAddon
Engine[2] = LibStub("AceLocale-3.0"):GetLocale(AddonName)
Engine[3] = Defaults

_G["SoulEnergyTracker"] = MyAddon

function MyAddon:OnInitialize()
  self.printFuncName("OnInitialize")
  -- Do init tasks here, like loading the Saved Variables,
  -- or setting up slash commands.
  SLASH_SOULENERGY1 = "/se"
  SLASH_SOULENERGY2 = "/soulenergy"

  self:CheckSettings()

  self:RegisterEvent("PLAYER_TARGET_CHANGED")
  SlashCmdList["SOULENERGY"] = function( ... )
    self:HandleChatCommand(...)
  end
end


function MyAddon:OnEnable()
  self.printFuncName("OnEnable")
  -- Do more initialization here, that really enables the use of your addon.
  -- Register Events, Hook functions, Create Frames, Get information from
  -- the game that wasn't available in OnInitialize

  self:RegisterComm("SETracker")

  if SoulEnergyTrackerData._LastChange ~= -1 then
    self:StartUpdating(false)
  end

  self:RunUpdate()
end


function MyAddon:OnDisable()
  self.printFuncName("OnDisable")
  -- Unhook, Unregister Events, Hide frames that you created.
  -- You would probably only use an OnDisable if you want to
  -- build a "standby" mode, or be able to toggle modules on/off.
  self:StopUpdating()
  self._ShowBar = false
end


